## Gridworld problem with initial position I, two system goals G, and
## a dynamic obstacle that can move in any cell with "+" but must
## always eventually return to E.  (The cells labeled "G" and "I"
## should also have "+" for this problem.)
##
##    0 1 2 3
##   ---------
##  0|E|+|G| |
##   ---------
##  1|+|+|G|*|
##   ---------
##  2|*|+|I|*|
##   ---------
##  3| | | | |
##   ---------

# The following is a TuLiP GridWorld description string of the world
# without the troll.
#
# 4 4
#   G 
#   G*
# * I*
#     


ENV: X_0_r [0,2] X_0_c [0,2];
SYS: Y_r [0,3] Y_c [0,3];

ENVINIT: (((X_0_r = 0) & (X_0_c = 0)));
ENVTRANS: [](((X_0_r = 0) & (X_0_c = 0)) -> (((X_0_r' = 0) & (X_0_c' = 0)) | ((X_0_r' = 1) & (X_0_c' = 0)) | ((X_0_r' = 0) & (X_0_c' = 1))))
& [](((X_0_r = 0) & (X_0_c = 1)) -> (((X_0_r' = 0) & (X_0_c' = 1)) | ((X_0_r' = 0) & (X_0_c' = 0)) | ((X_0_r' = 1) & (X_0_c' = 1)) | ((X_0_r' = 0) & (X_0_c' = 2))))
& [](((X_0_r = 0) & (X_0_c = 2)) -> (((X_0_r' = 0) & (X_0_c' = 2)) | ((X_0_r' = 0) & (X_0_c' = 1)) | ((X_0_r' = 1) & (X_0_c' = 2))))
& [](((X_0_r = 1) & (X_0_c = 0)) -> (((X_0_r' = 1) & (X_0_c' = 0)) | ((X_0_r' = 0) & (X_0_c' = 0)) | ((X_0_r' = 1) & (X_0_c' = 1))))
& [](((X_0_r = 1) & (X_0_c = 1)) -> (((X_0_r' = 1) & (X_0_c' = 1)) | ((X_0_r' = 0) & (X_0_c' = 1)) | ((X_0_r' = 1) & (X_0_c' = 0)) | ((X_0_r' = 2) & (X_0_c' = 1)) | ((X_0_r' = 1) & (X_0_c' = 2))))
& [](((X_0_r = 1) & (X_0_c = 2)) -> (((X_0_r' = 1) & (X_0_c' = 2)) | ((X_0_r' = 0) & (X_0_c' = 2)) | ((X_0_r' = 1) & (X_0_c' = 1)) | ((X_0_r' = 2) & (X_0_c' = 2))))
& [](((X_0_r = 2) & (X_0_c = 1)) -> (((X_0_r' = 2) & (X_0_c' = 1)) | ((X_0_r' = 1) & (X_0_c' = 1)) | ((X_0_r' = 2) & (X_0_c' = 2))))
& [](((X_0_r = 2) & (X_0_c = 2)) -> (((X_0_r' = 2) & (X_0_c' = 2)) | ((X_0_r' = 1) & (X_0_c' = 2)) | ((X_0_r' = 2) & (X_0_c' = 1))))
& [](!(((X_0_r' = 2) & (X_0_c' = 0))));
ENVGOAL: []<>(((X_0_r = 0) & (X_0_c = 0)));

SYSINIT: (((Y_r = 2) & (Y_c = 2)));
SYSTRANS: [](((Y_r = 0) & (Y_c = 0)) -> (((Y_r' = 0) & (Y_c' = 0)) | ((Y_r' = 1) & (Y_c' = 0)) | ((Y_r' = 0) & (Y_c' = 1))))
& [](((Y_r = 0) & (Y_c = 1)) -> (((Y_r' = 0) & (Y_c' = 1)) | ((Y_r' = 0) & (Y_c' = 0)) | ((Y_r' = 1) & (Y_c' = 1)) | ((Y_r' = 0) & (Y_c' = 2))))
& [](((Y_r = 0) & (Y_c = 2)) -> (((Y_r' = 0) & (Y_c' = 2)) | ((Y_r' = 0) & (Y_c' = 1)) | ((Y_r' = 1) & (Y_c' = 2)) | ((Y_r' = 0) & (Y_c' = 3))))
& [](((Y_r = 0) & (Y_c = 3)) -> (((Y_r' = 0) & (Y_c' = 3)) | ((Y_r' = 0) & (Y_c' = 2))))
& [](((Y_r = 1) & (Y_c = 0)) -> (((Y_r' = 1) & (Y_c' = 0)) | ((Y_r' = 0) & (Y_c' = 0)) | ((Y_r' = 1) & (Y_c' = 1))))
& [](((Y_r = 1) & (Y_c = 1)) -> (((Y_r' = 1) & (Y_c' = 1)) | ((Y_r' = 0) & (Y_c' = 1)) | ((Y_r' = 1) & (Y_c' = 0)) | ((Y_r' = 2) & (Y_c' = 1)) | ((Y_r' = 1) & (Y_c' = 2))))
& [](((Y_r = 1) & (Y_c = 2)) -> (((Y_r' = 1) & (Y_c' = 2)) | ((Y_r' = 0) & (Y_c' = 2)) | ((Y_r' = 1) & (Y_c' = 1)) | ((Y_r' = 2) & (Y_c' = 2))))
& [](((Y_r = 2) & (Y_c = 1)) -> (((Y_r' = 2) & (Y_c' = 1)) | ((Y_r' = 1) & (Y_c' = 1)) | ((Y_r' = 3) & (Y_c' = 1)) | ((Y_r' = 2) & (Y_c' = 2))))
& [](((Y_r = 2) & (Y_c = 2)) -> (((Y_r' = 2) & (Y_c' = 2)) | ((Y_r' = 1) & (Y_c' = 2)) | ((Y_r' = 2) & (Y_c' = 1)) | ((Y_r' = 3) & (Y_c' = 2))))
& [](((Y_r = 3) & (Y_c = 0)) -> (((Y_r' = 3) & (Y_c' = 0)) | ((Y_r' = 3) & (Y_c' = 1))))
& [](((Y_r = 3) & (Y_c = 1)) -> (((Y_r' = 3) & (Y_c' = 1)) | ((Y_r' = 2) & (Y_c' = 1)) | ((Y_r' = 3) & (Y_c' = 0)) | ((Y_r' = 3) & (Y_c' = 2))))
& [](((Y_r = 3) & (Y_c = 2)) -> (((Y_r' = 3) & (Y_c' = 2)) | ((Y_r' = 2) & (Y_c' = 2)) | ((Y_r' = 3) & (Y_c' = 1)) | ((Y_r' = 3) & (Y_c' = 3))))
& [](((Y_r = 3) & (Y_c = 3)) -> (((Y_r' = 3) & (Y_c' = 3)) | ((Y_r' = 3) & (Y_c' = 2))))
& [](!(((Y_r' = 1) & (Y_c' = 3))))
& [](!(((Y_r' = 2) & (Y_c' = 0))))
& [](!(((Y_r' = 2) & (Y_c' = 3))))
& [](!(((Y_r' = 0) & (Y_c' = 0)) & ((X_0_r' = 0) & (X_0_c' = 0))))
& [](!(((Y_r' = 0) & (Y_c' = 1)) & ((X_0_r' = 0) & (X_0_c' = 1))))
& [](!(((Y_r' = 0) & (Y_c' = 2)) & ((X_0_r' = 0) & (X_0_c' = 2))))
& [](!(((Y_r' = 1) & (Y_c' = 0)) & ((X_0_r' = 1) & (X_0_c' = 0))))
& [](!(((Y_r' = 1) & (Y_c' = 1)) & ((X_0_r' = 1) & (X_0_c' = 1))))
& [](!(((Y_r' = 1) & (Y_c' = 2)) & ((X_0_r' = 1) & (X_0_c' = 2))))
& [](!(((Y_r' = 2) & (Y_c' = 0)) & ((X_0_r' = 2) & (X_0_c' = 0))))
& [](!(((Y_r' = 2) & (Y_c' = 1)) & ((X_0_r' = 2) & (X_0_c' = 1))))
& [](!(((Y_r' = 2) & (Y_c' = 2)) & ((X_0_r' = 2) & (X_0_c' = 2))));
SYSGOAL: []<>(((Y_r = 1) & (Y_c = 2)))
& []<>(((Y_r = 0) & (Y_c = 2)));

